From 4aea27578878bdd8416a2c95defcef57d9d65302 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 28 2020 06:55:55 +0000
Subject: [PATCH 19/2232] Use clap's required_unless to enforce input file path


---

diff --git a/cmd/src/main.rs b/cmd/src/main.rs
index 8550261..c0b4cc4 100644
--- a/cmd/src/main.rs
+++ b/cmd/src/main.rs
@@ -4,14 +4,13 @@ mod syntax;
 use gen::include;
 use std::io::{self, Write};
 use std::path::PathBuf;
-use std::process;
 use structopt::StructOpt;
 
 #[derive(StructOpt, Debug)]
 #[structopt(name = "cxxbridge", author)]
 struct Opt {
     /// Input Rust source file containing #[cxx::bridge]
-    #[structopt(parse(from_os_str))]
+    #[structopt(parse(from_os_str), required_unless = "header")]
     input: Option<PathBuf>,
 
     /// Emit header with declarations only
@@ -19,22 +18,17 @@ struct Opt {
     header: bool,
 }
 
+fn write(content: impl AsRef<[u8]>) {
+    let _ = io::stdout().lock().write_all(content.as_ref());
+}
+
 fn main() {
     let opt = Opt::from_args();
 
-    if let Some(input) = opt.input {
-        let gen = if opt.header {
-            gen::do_generate_header
-        } else {
-            gen::do_generate_bridge
-        };
-        let bridge = gen(&input);
-        let _ = io::stdout().lock().write_all(bridge.as_ref());
-    } else if opt.header {
-        let header = include::HEADER;
-        let _ = io::stdout().lock().write_all(header.as_ref());
-    } else {
-        let _ = Opt::clap().after_help("").print_help();
-        process::exit(1);
+    match (opt.input, opt.header) {
+        (Some(input), true) => write(gen::do_generate_header(&input)),
+        (Some(input), false) => write(gen::do_generate_bridge(&input)),
+        (None, true) => write(include::HEADER),
+        (None, false) => unreachable!(), // enforced by required_unless
     }
 }

